Index: Singular/tesths.cc
===================================================================
--- Singular/tesths.cc	(revision 231b0fd0173552d615fba69018a64ff5510211be)
+++ Singular/tesths.cc	(revision 018577ef150959aa2cb45fc6f4167e9ef1096972)
@@ -134,6 +134,7 @@
   On(SW_USE_EZGCD);
   On(SW_USE_CHINREM_GCD);
+  //On(SW_USE_FF_MOD_GCD);
   //On(SW_USE_fieldGCD);
-  //On(SW_USE_EZGCD_P);
+  On(SW_USE_EZGCD_P);
   On(SW_USE_QGCD);
   Off(SW_USE_NTL_SORT); // may be changed by an command line option
Index: factory/cf_gcd.cc
===================================================================
--- factory/cf_gcd.cc	(revision 231b0fd0173552d615fba69018a64ff5510211be)
+++ factory/cf_gcd.cc	(revision 018577ef150959aa2cb45fc6f4167e9ef1096972)
@@ -29,5 +29,4 @@
 bool isPurePoly(const CanonicalForm & );
 static CanonicalForm gcd_univar_ntl0( const CanonicalForm &, const CanonicalForm & );
-static CanonicalForm gcd_univar_ntlp( const CanonicalForm &, const CanonicalForm & );
 #endif
 
@@ -367,83 +366,4 @@
 
 static CanonicalForm
-gcd_poly_p( const CanonicalForm & f, const CanonicalForm & g )
-{
-    CanonicalForm pi, pi1;
-    CanonicalForm C, Ci, Ci1, Hi, bi, pi2;
-    bool bpure;
-    int delta = degree( f ) - degree( g );
-
-    if ( delta >= 0 )
-    {
-        pi = f; pi1 = g;
-    }
-    else
-    {
-        pi = g; pi1 = f; delta = -delta;
-    }
-    Ci = content( pi ); Ci1 = content( pi1 );
-    pi1 = pi1 / Ci1; pi = pi / Ci;
-    C = gcd( Ci, Ci1 );
-    if ( !( pi.isUnivariate() && pi1.isUnivariate() ) )
-    {
-        //out_cf("F:",f,"\n");
-        //out_cf("G:",g,"\n");
-        //out_cf("newGCD:",newGCD(f,g),"\n");
-        if (isOn(SW_USE_GCD_P) && (getCharacteristic()>0))
-        {
-          return newGCD(f,g);
-        }
-        if ( gcd_test_one( pi1, pi, true ) )
-        {
-          C=abs(C);
-          //out_cf("GCD:",C,"\n");
-          return C;
-        }
-        bpure = false;
-    }
-    else
-    {
-        bpure = isPurePoly(pi) && isPurePoly(pi1);
-#ifdef HAVE_NTL
-        if ( isOn(SW_USE_NTL_GCD_P) && bpure && (CFFactory::gettype() != GaloisFieldDomain))
-            return gcd_univar_ntlp(pi, pi1 ) * C;
-#endif
-    }
-    Variable v = f.mvar();
-    Hi = power( LC( pi1, v ), delta );
-    if ( (delta+1) % 2 )
-        bi = 1;
-    else
-        bi = -1;
-    while ( degree( pi1, v ) > 0 )
-    {
-        pi2 = psr( pi, pi1, v );
-        pi2 = pi2 / bi;
-        pi = pi1; pi1 = pi2;
-        if ( degree( pi1, v ) > 0 )
-        {
-            delta = degree( pi, v ) - degree( pi1, v );
-            if ( (delta+1) % 2 )
-                bi = LC( pi, v ) * power( Hi, delta );
-            else
-                bi = -LC( pi, v ) * power( Hi, delta );
-            Hi = power( LC( pi1, v ), delta ) / power( Hi, delta-1 );
-        }
-    }
-    if ( degree( pi1, v ) == 0 )
-    {
-      C=abs(C);
-      //out_cf("GCD:",C,"\n");
-      return C;
-    }
-    pi /= content( pi );
-    if ( bpure )
-        pi /= pi.lc();
-    C=abs(C*pi);
-    //out_cf("GCD:",C,"\n");
-    return C;
-}
-
-static CanonicalForm
 gcd_poly_0( const CanonicalForm & f, const CanonicalForm & g )
 {
@@ -566,19 +486,5 @@
     else if (isOn( SW_USE_EZGCD_P ) && (!fc_and_gc_Univariate))
     {
-      if ( pe == 1 )
-        fc = fin_ezgcd( fc, gc );
-      else if ( pe > 0 )// no variable at position 1
-      {
-        fc = replacevar( fc, Variable(pe), Variable(1) );
-        gc = replacevar( gc, Variable(pe), Variable(1) );
-        fc = replacevar( fin_ezgcd( fc, gc ), Variable(1), Variable(pe) );
-      }
-      else
-      {
-        pe = -pe;
-        fc = swapvar( fc, Variable(pe), Variable(1) );
-        gc = swapvar( gc, Variable(pe), Variable(1) );
-        fc = swapvar( fin_ezgcd( fc, gc ), Variable(1), Variable(pe) );
-      }
+      fc= EZGCD_P (fc, gc);
     }
     else if (isOn(SW_USE_GCD_P))
@@ -926,37 +832,4 @@
 }
 
-static CanonicalForm
-gcd_univar_ntlp( const CanonicalForm & F, const CanonicalForm & G )
-{
-  if (fac_NTL_char!=getCharacteristic())
-  {
-    fac_NTL_char=getCharacteristic();
-    #ifdef NTL_ZZ
-    ZZ r;
-    r=getCharacteristic();
-    ZZ_pContext ccc(r);
-    #else
-    zz_pContext ccc(getCharacteristic());
-    #endif
-    ccc.restore();
-    #ifdef NTL_ZZ
-    ZZ_p::init(r);
-    #else
-    zz_p::init(getCharacteristic());
-    #endif
-  }
-  #ifdef NTL_ZZ
-  ZZ_pX F1=convertFacCF2NTLZZpX(F);
-  ZZ_pX G1=convertFacCF2NTLZZpX(G);
-  ZZ_pX R=GCD(F1,G1);
-  return  convertNTLZZpX2CF(R,F.mvar());
-  #else
-  zz_pX F1=convertFacCF2NTLzzpX(F);
-  zz_pX G1=convertFacCF2NTLzzpX(G);
-  zz_pX R=GCD(F1,G1);
-  return  convertNTLzzpX2CF(R,F.mvar());
-  #endif
-}
-
 #endif
 
Index: factory/cf_gcd_smallp.cc
===================================================================
--- factory/cf_gcd_smallp.cc	(revision 231b0fd0173552d615fba69018a64ff5510211be)
+++ factory/cf_gcd_smallp.cc	(revision 018577ef150959aa2cb45fc6f4167e9ef1096972)
@@ -30,6 +30,12 @@
 #include "ftmpl_functions.h"
 #include "cf_random.h"
-
-// iinline helper functions:
+#include "cf_algorithm.h"
+#include "ffreval.h" 
+#include "fac_iterfor.h" 
+#include "cf_binom.h" 
+#include "facHensel.h"
+#include "facFqFactorizeUtil.h"
+
+// inline helper functions:
 #include "cf_map_ext.h"
 
@@ -46,9 +52,120 @@
 TIMING_DEFINE_PRINT(newton_interpolation);
 
+CanonicalForm
+gcd_univar_ntlp( const CanonicalForm & F, const CanonicalForm & G )
+{
+  if (fac_NTL_char!=getCharacteristic())
+  {
+    fac_NTL_char=getCharacteristic();
+    #ifdef NTL_ZZ
+    ZZ r;
+    r=getCharacteristic();
+    ZZ_pContext ccc(r);
+    #else
+    zz_pContext ccc(getCharacteristic());
+    #endif
+    ccc.restore();
+    #ifdef NTL_ZZ
+    ZZ_p::init(r);
+    #else
+    zz_p::init(getCharacteristic());
+    #endif
+  }
+  #ifdef NTL_ZZ
+  ZZ_pX F1=convertFacCF2NTLZZpX(F);
+  ZZ_pX G1=convertFacCF2NTLZZpX(G);
+  ZZ_pX R=GCD(F1,G1);
+  return  convertNTLZZpX2CF(R,F.mvar());
+  #else
+  zz_pX F1=convertFacCF2NTLzzpX(F);
+  zz_pX G1=convertFacCF2NTLzzpX(G);
+  zz_pX R=GCD(F1,G1);
+  return  convertNTLzzpX2CF(R,F.mvar());
+  #endif
+}
+
+#endif
+
+CanonicalForm
+gcd_poly_p( const CanonicalForm & f, const CanonicalForm & g)
+{
+    CanonicalForm pi, pi1;
+    CanonicalForm C, Ci, Ci1, Hi, bi, pi2;
+    bool bpure;
+    int delta = degree( f ) - degree( g );
+
+    if ( delta >= 0 )
+    {
+        pi = f; pi1 = g;
+    }
+    else
+    {
+        pi = g; pi1 = f; delta = -delta;
+    }
+    Ci = content( pi ); Ci1 = content( pi1 );
+    pi1 = pi1 / Ci1; pi = pi / Ci;
+    C = gcd( Ci, Ci1 );
+    if ( !( pi.isUnivariate() && pi1.isUnivariate() ) )
+    {
+        //out_cf("F:",f,"\n");
+        //out_cf("G:",g,"\n");
+        //out_cf("newGCD:",newGCD(f,g),"\n");
+        if ( gcd_test_one( pi1, pi, true ) )
+        {
+          C=abs(C);
+          //out_cf("GCD:",C,"\n");
+          return C;
+        }
+        bpure = false;
+    }
+    else
+    {
+        bpure = isPurePoly(pi) && isPurePoly(pi1);
+#ifdef HAVE_NTL
+        if ( isOn(SW_USE_NTL_GCD_P) && bpure && (CFFactory::gettype() != GaloisFieldDomain))
+            return gcd_univar_ntlp(pi, pi1 ) * C;
+#endif
+    }
+    Variable v = f.mvar();
+    Hi = power( LC( pi1, v ), delta );
+    if ( (delta+1) % 2 )
+        bi = 1;
+    else
+        bi = -1;
+    while ( degree( pi1, v ) > 0 )
+    {
+        pi2 = psr( pi, pi1, v );
+        pi2 = pi2 / bi;
+        pi = pi1; pi1 = pi2;
+        if ( degree( pi1, v ) > 0 )
+        {
+            delta = degree( pi, v ) - degree( pi1, v );
+            if ( (delta+1) % 2 )
+                bi = LC( pi, v ) * power( Hi, delta );
+            else
+                bi = -LC( pi, v ) * power( Hi, delta );
+            Hi = power( LC( pi1, v ), delta ) / power( Hi, delta-1 );
+        }
+    }
+    if ( degree( pi1, v ) == 0 )
+    {
+      C=abs(C);
+      //out_cf("GCD:",C,"\n");
+      return C;
+    }
+    pi /= content( pi );
+    if ( bpure )
+        pi /= pi.lc();
+    C=abs(C*pi);
+    //out_cf("GCD:",C,"\n");
+    return C;
+}
+
+#ifdef HAVE_NTL
 /// compressing two polynomials F and G, M is used for compressing, 
 /// N to reverse the compression
 static inline
 int myCompress (const CanonicalForm& F, const CanonicalForm& G, CFMap & M,
-                CFMap & N, bool& top_level) 
+                CFMap & N, const bool& topLevel) 
 { 
   int n= tmax (F.level(), G.level());
@@ -67,5 +184,5 @@
   int both_zero= 0;
 
-  if (top_level) 
+  if (topLevel) 
   {
     for (int i= 1; i <= n; i++) 
@@ -198,6 +315,158 @@
   delete [] degsg;
 
-  return 1;
+  if (topLevel)
+    return both_non_zero;
+  else
+    return 1;
 }
+
+CanonicalForm 
+uniCoeff (const CanonicalForm& F)
+{
+  if (F.inCoeffDomain())
+    return F;
+  if (F.isUnivariate() && F.level() == 1)
+    return F;
+  else if (F.isUnivariate () && F.level() != 1)
+    return 0;
+  CanonicalForm result= 0;
+  if (F.level() == 2)
+  {
+    for (CFIterator i= F; i.hasTerms(); i++)
+      result += i.coeff();
+  }
+  else
+  {
+    for (CFIterator i= F; i.hasTerms(); i++)
+      result += uniCoeff (i.coeff());
+  }
+  return result;
+}
+
+int
+substituteCheck (const CanonicalForm& F, const CanonicalForm& G) 
+{
+  if (F.inBaseDomain() || G.inBaseDomain())
+    return 0;
+  Variable x= Variable (1);
+  CanonicalForm f= swapvar (F, F.mvar(), x); //TODO swapping seems to be pretty expensive 
+  CanonicalForm g= swapvar (G, G.mvar(), x); 
+  int sizef= 0;
+  int sizeg= 0; 
+  for (CFIterator i= f; i.hasTerms(); i++, sizef++)
+  {
+    if (i.exp() == 1)
+      return 0;
+  }
+  for (CFIterator i= g; i.hasTerms(); i++, sizeg++)
+  {
+    if (i.exp() == 1)
+      return 0;
+  }
+  int * expf= new int [sizef];
+  int * expg= new int [sizeg];
+  int j= 0;
+  for (CFIterator i= f; i.hasTerms(); i++, j++)
+  {
+    expf [j]= i.exp();
+  }
+  j= 0;
+  for (CFIterator i= g; i.hasTerms(); i++, j++)
+  {
+    expg [j]= i.exp();
+  }
+  
+  int indf= sizef - 1;
+  int indg= sizeg - 1;
+  if (expf[indf] == 0)
+    indf--;
+  if (expg[indg] == 0)
+    indg--;
+    
+  if (expg[indg] != expf [indf] || (expg[indg] == 1 && expf[indf] == 1))
+    return 0;
+  
+  // expf[indg] == expf[indf] after here
+  int result= expg[indg];
+  for (int i= indf - 1; i >= 0; i--)
+  {
+    if (expf [i]%result != 0)
+      return 0;
+  }
+  
+  for (int i= indg - 1; i >= 0; i--)
+  {
+    if (expg [i]%result != 0)
+      return 0;
+  }
+
+  delete [] expg;
+  delete [] expf;
+  return result;
+}
+
+// substiution
+void 
+subst (const CanonicalForm& F, const CanonicalForm& G, CanonicalForm& A, 
+       CanonicalForm& B, const int d
+      )
+{
+  if (d == 1)
+  {
+    A= F;
+    B= G;
+    return;
+  }
+  
+  CanonicalForm C= 0;
+  CanonicalForm D= 0;  
+  Variable x= Variable (1);
+  CanonicalForm f= swapvar (F, x, F.mvar());
+  CanonicalForm g= swapvar (G, x, G.mvar());
+  for (CFIterator i= f; i.hasTerms(); i++)
+    C += i.coeff()*power (f.mvar(), i.exp()/ d);
+  for (CFIterator i= g; i.hasTerms(); i++)
+    D += i.coeff()*power (g.mvar(), i.exp()/ d);
+  A= swapvar (C, x, F.mvar());
+  B= swapvar (D, x, G.mvar());
+}
+
+CanonicalForm 
+reverseSubst (const CanonicalForm& F, const int d)
+{
+  if (d == 1)
+    return F;
+  
+  Variable x= Variable (1);
+  CanonicalForm f= swapvar (F, x, F.mvar());
+  CanonicalForm result= 0;
+  for (CFIterator i= f; i.hasTerms(); i++)
+    result += i.coeff()*power (f.mvar(), d*i.exp());
+  return swapvar (result, x, F.mvar()); 
+  
+}
+
+static inline CanonicalForm 
+uni_content (const CanonicalForm & F);
+
+CanonicalForm
+uni_content (const CanonicalForm& F, const Variable& x)
+{
+  if (F.inBaseDomain())
+    return F.genOne();
+  if (F.level() == x.level() && F.isUnivariate())
+    return F;
+  if (F.level() != x.level() && F.isUnivariate())
+    return F.genOne();
+    
+  if (x.level() != 1)
+  {
+    CanonicalForm f= swapvar (F, x, Variable (1));
+    CanonicalForm result= uni_content (f);
+    return swapvar (result, x, Variable (1));
+  }
+  else
+    return uni_content (F);
+} 
 
 /// compute the content of F, where F is considered as an element of 
@@ -212,5 +481,5 @@
   if (F.level() != 1 && F.isUnivariate())
     return F.genOne();
-  if (degree (F,1) == 0) return F.genOne();
+  if (degree (F, 1) == 0) return F.genOne();
 
   int l= F.level();
@@ -233,7 +502,32 @@
 }
 
+CanonicalForm 
+extractContents (const CanonicalForm& F, const CanonicalForm& G, 
+                 CanonicalForm& contentF, CanonicalForm& contentG, 
+                 CanonicalForm& ppF, CanonicalForm& ppG, const int d)
+{
+  CanonicalForm uniContentF, uniContentG, gcdcFcG;
+  contentF= 1;
+  contentG= 1;
+  ppF= F;
+  ppG= G;
+  CanonicalForm result= 1;
+  for (int i= 1; i <= d; i++)
+  {
+    uniContentF= uni_content (F, Variable (i));
+    uniContentG= uni_content (G, Variable (i));
+    gcdcFcG= gcd (uniContentF, uniContentG);
+    contentF *= uniContentF;
+    contentG *= uniContentG;
+    ppF /= uniContentF;
+    ppG /= uniContentG;
+    result *= gcdcFcG;
+  }
+  return result;
+}
+
 /// compute the leading coefficient of F, where F is considered as an element
 /// of \f$ R[x_{1}][x_{2},\ldots ,x_{n}] \f$, order on Mon (x_{2},\ldots ,x_{n})
-/// is dp.
+/// is Dp.
 static inline
 CanonicalForm uni_lcoeff (const CanonicalForm& F) 
@@ -286,5 +580,5 @@
   int p= getCharacteristic ();
   int d= degree (mipo);
-  int bound= ipower (p, d);
+  double bound= pow ((double) p, d);
   do 
   {
@@ -326,5 +620,5 @@
   ZZ_pX NTLirredpoly;
   //TODO: replace d by max_{i} (deg_x{i}(f))
-  int i= (int) (log ((double) ipower (d + 1, num_vars))/log ((double) p)); 
+  int i= (int) (log ((double) pow ((double) d + 1, (double) num_vars))/log ((double) p));
   int m= degree (getMipo (beta));
   if (i <= 1)
@@ -336,10 +630,10 @@
 
 /// GCD of F and G over \f$ F_{p}(\alpha ) \f$ , 
-/// l and top_level are only used internally, output is monic
+/// l and topLevel are only used internally, output is monic
 /// based on Alg. 7.2. as described in "Algorithms for
 /// Computer Algebra" by Geddes, Czapor, Labahn
 CanonicalForm 
 GCD_Fp_extension (const CanonicalForm& F, const CanonicalForm& G, 
-                  Variable & alpha, CFList& l, bool& top_level) 
+                  Variable & alpha, CFList& l, bool& topLevel) 
 { 
   CanonicalForm A= F;
@@ -354,5 +648,5 @@
  
   CFMap M,N;
-  int best_level= myCompress (A, B, M, N, top_level);
+  int best_level= myCompress (A, B, M, N, topLevel);
 
   if (best_level == 0) return B.genOne();
@@ -366,16 +660,28 @@
   if (A.isUnivariate() && B.isUnivariate()) 
     return N (gcd(A,B)); 
-  
+
+  int substitute= substituteCheck (A, B);
+  
+  if (substitute > 1)
+    subst (A, B, A, B, substitute);
+    
   CanonicalForm cA, cB;    // content of A and B
   CanonicalForm ppA, ppB;    // primitive part of A and B
   CanonicalForm gcdcAcB;
-
-  cA = uni_content (A);
-  cB = uni_content (B);
-
-  gcdcAcB= gcd (cA, cB);
-
-  ppA= A/cA;
-  ppB= B/cB;
+  if (topLevel)
+  {
+    if (best_level <= 2)
+      gcdcAcB= extractContents (A, B, cA, cB, ppA, ppB, best_level);
+    else 
+      gcdcAcB= extractContents (A, B, cA, cB, ppA, ppB, 2); // TODO needs some more tuning 
+  }
+  else
+  {
+    cA = uni_content (A);
+    cB = uni_content (B); 
+    gcdcAcB= gcd (cA, cB);
+    ppA= A/cA;
+    ppB= B/cB;
+  }
 
   CanonicalForm lcA, lcB;  // leading coefficients of A and B
@@ -399,9 +705,21 @@
   int d= totaldegree (ppA, Variable(2), Variable (ppA.level()));
 
-  if (d == 0) return N(gcdcAcB);
+  if (d == 0) 
+  {
+    if (substitute > 1)
+      return N (reverseSubst (gcdcAcB, substitute));
+    else 
+      return N(gcdcAcB);
+  }
   int d0= totaldegree (ppB, Variable(2), Variable (ppB.level()));
   if (d0 < d) 
     d= d0; 
-  if (d == 0) return N(gcdcAcB);
+  if (d == 0) 
+  {
+    if (substitute > 1)
+      return N (reverseSubst (gcdcAcB, substitute));
+    else 
+      return N(gcdcAcB);
+  }
 
   CanonicalForm m, random_element, G_m, G_random_element, H, cH, ppH;
@@ -413,5 +731,5 @@
   H= 0;
   bool fail= false;
-  top_level= false;
+  topLevel= false;
   bool inextension= false;
   Variable V_buf= alpha;
@@ -427,10 +745,9 @@
       int num_vars= tmin (getNumVars(A), getNumVars(B));
       num_vars--;
-
+      
       choose_extension (d, num_vars, V_buf);
       bool prim_fail= false;
       Variable V_buf2;
       prim_elem= primitiveElement (alpha, V_buf2, prim_fail);
-
       ASSERT (!prim_fail, "failure in integer factorizer");
       if (prim_fail)
@@ -438,5 +755,5 @@
       else
         im_prim_elem= mapPrimElem (prim_elem, alpha, V_buf);
-
+      
       DEBOUTLN (cerr, "getMipo (alpha)= " << getMipo (alpha));
       DEBOUTLN (cerr, "getMipo (V_buf2)= " << getMipo (V_buf2));
@@ -461,5 +778,5 @@
       G_random_element= 
       GCD_Fp_extension (ppA (random_element, x), ppB (random_element, x), V_buf,
-                        list, top_level);
+                        list, topLevel);
       TIMING_END_AND_PRINT (gcd_recursion, 
                             "time for recursive call: ");
@@ -472,5 +789,5 @@
       G_random_element= 
       GCD_Fp_extension (ppA(random_element, x), ppB(random_element, x), V_buf,
-                        list, top_level);
+                        list, topLevel);
       TIMING_END_AND_PRINT (gcd_recursion, 
                             "time for recursive call: ");
@@ -480,5 +797,11 @@
     d0= totaldegree (G_random_element, Variable(2), 
                      Variable (G_random_element.level()));
-    if (d0 == 0) return N(gcdcAcB); 
+    if (d0 == 0)
+    {
+      if (substitute > 1)
+        return N (reverseSubst (gcdcAcB, substitute));
+      else
+        return N(gcdcAcB); 
+    }
     if (d0 >  d) 
     {
@@ -521,9 +844,23 @@
         ppH /= Lc(ppH);
         DEBOUTLN (cerr, "ppH after mapDown= " << ppH);
-        if (fdivides (ppH, A) && fdivides (ppH, B))         
+        if (fdivides (ppH, A) && fdivides (ppH, B))
+        {
+          if (substitute > 1)
+          {
+            ppH= reverseSubst (ppH, substitute);
+            gcdcAcB= reverseSubst (gcdcAcB, substitute);
+          }
           return N(gcdcAcB*ppH);
-      }
-      else if (fdivides (ppH, A) && fdivides (ppH, B)) 
-        return N(gcdcAcB*(ppH/Lc(ppH)));
+        }
+      }
+      else if (fdivides (ppH, A) && fdivides (ppH, B))
+      {
+        if (substitute > 1)
+        {
+          ppH= reverseSubst (ppH, substitute);
+          gcdcAcB= reverseSubst (gcdcAcB, substitute);
+        }
+        return N(gcdcAcB*ppH);
+      }
     }
 
@@ -549,5 +886,5 @@
   int p= getCharacteristic();
   int d= getGFDegree();
-  int bound= ipower (p, d);
+  double bound= pow ((double) p, (double) d);
   do 
   {
@@ -580,5 +917,5 @@
 /// the size of the base field is bounded by 2^16, output is monic
 CanonicalForm GCD_GF (const CanonicalForm& F, const CanonicalForm& G,
-        CFList& l, bool& top_level) 
+        CFList& l, bool& topLevel) 
 { 
   CanonicalForm A= F;
@@ -593,5 +930,5 @@
  
   CFMap M,N;
-  int best_level= myCompress (A, B, M, N, top_level);
+  int best_level= myCompress (A, B, M, N, topLevel);
 
   if (best_level == 0) return B.genOne();
@@ -652,5 +989,5 @@
   H= 0;
   bool fail= false;
-  top_level= false;
+  topLevel= false;
   bool inextension= false;
   int p;
@@ -667,9 +1004,9 @@
       num_vars--;
       p= getCharacteristic();
-      expon= (int) floor ((log ((double) ipower (d + 1, num_vars))/log ((double) p)));
+      expon= (int) floor ((log ((double) pow ((double) d + 1, num_vars))/log ((double) p)));
       if (expon < 2)
         expon= 2;
       kk= getGFDegree(); 
-      if (ipower (p, kk*expon) < (1 << 16)) 
+      if (pow ( (double) p, kk*expon) < (1 << 16)) 
         setCharacteristic (p, kk*(int)expon, 'b');
       else 
@@ -694,5 +1031,5 @@
       TIMING_START (gcd_recursion);
       G_random_element= GCD_GF (ppA(random_element, x), ppB(random_element, x), 
-                                list, top_level);
+                                list, topLevel);
       TIMING_END_AND_PRINT (gcd_recursion, 
                             "time for recursive call: ");
@@ -704,5 +1041,5 @@
       TIMING_START (gcd_recursion);
       G_random_element= GCD_GF (ppA(random_element, x), ppB(random_element, x), 
-                                list, top_level);
+                                list, topLevel);
       TIMING_END_AND_PRINT (gcd_recursion, 
                             "time for recursive call: ");
@@ -829,5 +1166,5 @@
 
 CanonicalForm GCD_small_p (const CanonicalForm& F, const CanonicalForm&  G, 
-                           bool& top_level, CFList& l) 
+                           bool& topLevel, CFList& l) 
 {
   CanonicalForm A= F;
@@ -842,5 +1179,5 @@
 
   CFMap M,N;
-  int best_level= myCompress (A, B, M, N, top_level);
+  int best_level= myCompress (A, B, M, N, topLevel);
 
   if (best_level == 0) return B.genOne();
@@ -848,19 +1185,34 @@
   A= M(A);
   B= M(B);
-
-  Variable x= Variable (1);
 
   //univariate case 
   if (A.isUnivariate() && B.isUnivariate()) 
     return N (gcd (A, B));
+    
+  int substitute= substituteCheck (A, B);
+  
+  if (substitute > 1)
+    subst (A, B, A, B, substitute);
+    
+  Variable x= Variable (1);
 
   CanonicalForm cA, cB;    // content of A and B
   CanonicalForm ppA, ppB;    // primitive part of A and B
   CanonicalForm gcdcAcB;
-  cA = uni_content (A);
-  cB = uni_content (B); 
-  gcdcAcB= gcd (cA, cB);
-  ppA= A/cA;
-  ppB= B/cB;
+  if (topLevel)
+  {
+    if (best_level <= 2)
+      gcdcAcB= extractContents (A, B, cA, cB, ppA, ppB, best_level);
+    else 
+      gcdcAcB= extractContents (A, B, cA, cB, ppA, ppB, 2); 
+  }
+  else
+  {
+    cA = uni_content (A);
+    cB = uni_content (B); 
+    gcdcAcB= gcd (cA, cB);
+    ppA= A/cA;
+    ppB= B/cB;
+  }
 
   CanonicalForm lcA, lcB;  // leading coefficients of A and B
@@ -879,5 +1231,5 @@
       return G/Lc(G);
   }
-
+  
   gcdlcAlcB= gcd (lcA, lcB); 
   
@@ -885,5 +1237,11 @@
   int d0;
 
-  if (d == 0) return N(gcdcAcB);
+  if (d == 0) 
+  {
+    if (substitute > 1)
+      return N (reverseSubst (gcdcAcB, substitute));
+    else 
+      return N(gcdcAcB);
+  }
   d0= totaldegree (ppB, Variable (2), Variable (ppB.level()));
 
@@ -891,5 +1249,11 @@
     d= d0;
 
-  if (d == 0) return N(gcdcAcB);
+  if (d == 0)
+  {
+    if (substitute > 1)
+      return N (reverseSubst (gcdcAcB, substitute));
+    else
+      return N(gcdcAcB);
+  }
 
   CanonicalForm m, random_element, G_m, G_random_element, H, cH, ppH;
@@ -899,9 +1263,8 @@
   G_m= 0;
   Variable alpha, V_buf;
-  int p, k;
   bool fail= false;
   bool inextension= false;
   bool inextensionextension= false;
-  top_level= false;
+  topLevel= false;
   CFList source, dest;
   do 
@@ -917,5 +1280,5 @@
       TIMING_START (gcd_recursion);
       G_random_element= 
-      GCD_small_p (ppA (random_element,x), ppB (random_element,x), top_level, 
+      GCD_small_p (ppA (random_element,x), ppB (random_element,x), topLevel, 
       list);
       TIMING_END_AND_PRINT (gcd_recursion, 
@@ -929,5 +1292,5 @@
       G_random_element= 
       GCD_Fp_extension (ppA (random_element, x), ppB (random_element, x), alpha, 
-                        list, top_level);
+                        list, topLevel);
       TIMING_END_AND_PRINT (gcd_recursion, 
                             "time for recursive call: ");
@@ -942,4 +1305,5 @@
       int deg= 2;
       do {
+        l= CFList();
         mipo= randomIrredpoly (deg, x); 
         alpha= rootOf (mipo);
@@ -948,10 +1312,10 @@
         random_element= randomElement (m, alpha, l, fail); 
         deg++;
-      } while (fail); 
+      } while (fail);
       list= CFList();
       TIMING_START (gcd_recursion);
       G_random_element= 
       GCD_Fp_extension (ppA (random_element, x), ppB (random_element, x), alpha, 
-                        list, top_level);
+                        list, topLevel);
       TIMING_END_AND_PRINT (gcd_recursion, 
                             "time for recursive call: ");
@@ -970,5 +1334,4 @@
       CanonicalForm prim_elem, im_prim_elem;
       prim_elem= primitiveElement (alpha, V_buf2, prim_fail);
-       
       ASSERT (!prim_fail, "failure in integer factorizer");
       if (prim_fail)
@@ -999,5 +1362,5 @@
       G_random_element= 
       GCD_Fp_extension (ppA (random_element, x), ppB (random_element, x), V_buf,
-                        list, top_level);
+                        list, topLevel);
       TIMING_END_AND_PRINT (gcd_recursion, 
                             "time for recursive call: ");
@@ -1011,5 +1374,8 @@
     if (d0 == 0)
     {
-      return N(gcdcAcB); 
+      if (substitute > 1)
+        return N (reverseSubst (gcdcAcB, substitute));
+      else
+        return N(gcdcAcB); 
     }
     if (d0 >  d) 
@@ -1047,6 +1413,13 @@
       ppH /= Lc (ppH);
       DEBOUTLN (cerr, "ppH= " << ppH);
-      if (fdivides (ppH, A) && fdivides (ppH, B)) 
+      if (fdivides (ppH, A) && fdivides (ppH, B))
+      {
+        if (substitute > 1)
+        {
+          ppH= reverseSubst (ppH, substitute);
+          gcdcAcB= reverseSubst (gcdcAcB, substitute);
+        }
         return N(gcdcAcB*ppH);
+      }
     }
 
